<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des utilisateurs</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total d'utilisateurs : {{ total }}</h3>
      </div>
      <div class="columns ">
        <div class="column is-one-third">
          <b-input
            v-model="filtreNom"
            placeholder="Rechercher par nom, prénom ou email..."
            rounded
            type="search"
            icon="magnify"
            clearable
          >
          </b-input>
        </div>
        <div class="column">
          <b-autocomplete
            v-model="organismeSearch"
            rounded
            :data="filteredOrganismeArray"
            placeholder="Rechercher par organisme..."
            icon="magnify"
            field="code"
            clearable
            @select="(option) => getUtilisateursOrganisme(option)"
            @input="organismeChange"
          >
            <template #empty>Aucun résultat</template>
            <template slot-scope="org">
              <div class="columns">
                <div class="column  is-2">
                  {{ org.option.code }}
                </div>
                <div class="column">
                  {{ org.option.libelle }}
                </div>
                <div class="column is-2">
                  {{ org.option.libelleTypeOrganisme }}
                </div>
              </div>
            </template>
          </b-autocomplete>
        </div>
        <div class="column is-narrow">
          <nuxt-link
            :to="{ name: 'profil-dashboard-utilisateurs-creer' }"
            tag="button"
            class="is-primary button has-text-weight-semibold"
          >
            <b-icon icon="plus" />&nbsp;&nbsp;Ajouter un utilisateur
          </nuxt-link>
        </div>
      </div>
      <div class="column columns">
        <div class="column is-narrow">
          <b-radio v-model="enabled" class="radioButton " native-value="" @input="triEnabled">Tous</b-radio>
        </div>
        <div class="column is-narrow">
          <b-radio v-model="enabled" class="radioButton is-narrow" native-value="true" @input="triEnabled"
            ><b-icon icon="lock-open" size="is-small" /> Activé</b-radio
          >
        </div>
        <div class="column is-narrow">
          <b-radio v-model="enabled" class="radioButton is-narrow" native-value="false" @input="triEnabled"
            ><b-icon icon="lock" size="is-small" />Désactivé</b-radio
          >
        </div>
      </div>
      <div class="columns is-centered">
        <div class="column columns">
          <b-button class="column is-half" type="is-light" :icon-right="getIconOrder('nom')" @click="tri('nom')"
            ><b>NOM</b></b-button
          >
          <b-button class="column is-half" type="is-light" :icon-right="getIconOrder('prenom')" @click="tri('prenom')"
            ><b>PRENOM</b></b-button
          >
        </div>
        <div class="column columns">
          <b-button type="is-light mt-border" :icon-right="getIconOrder('email')" expanded @click="tri('email')"
            ><b>EMAIL</b></b-button
          >
        </div>
        <div class="column columns">
          <b-button type="is-light" :icon-right="getIconOrder('o.code')" expanded @click="tri('o.code')"
            ><b>ORGANISME</b></b-button
          >
        </div>
        <div class="column is-narrow visibility">
          <b-button type="is-danger" icon-left="delete"></b-button>
          <b-button type="is-danger" icon-left="delete"></b-button>
        </div>
      </div>
    </div>
    <mt-list v-slot="{ item: utilisateur }" :list="filteredUtil()">
      <mt-list-item>
        <div class="columns is-vcentered">
          <div class="columns column mt-marginless-bottom">
            <div class="column is-narrow icone">
              <mt-utilisateur :utilisateur="utilisateur"
                ><b-icon v-if="!utilisateur.enabled" icon="lock" />
              </mt-utilisateur>
            </div>
          </div>
          <div class="column">
            {{ utilisateur.email }}
          </div>
          <div class="column columns">
            <div class="column">
              {{ utilisateur.affectation.organisme.code }}
            </div>
            <div v-if="utilisateur.affectation.organisme.codeParent" class="column">
              ({{ utilisateur.affectation.organisme.codeParent }})
            </div>
          </div>
          <div class="column is-narrow">
            <b-tooltip label="Modifier cet utilisateur" type="is-light">
              <nuxt-link
                :to="{ name: 'profil-dashboard-utilisateurs-id-editer', params: { id: utilisateur.id } }"
                class="columns column mt-marginless-bottom"
              >
                <b-button type="is-primary" icon-left="pencil"></b-button>
              </nuxt-link>
            </b-tooltip>
            <b-tooltip label="Supprimer cet utilisateur" type="is-light">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(utilisateur)"></b-button>
            </b-tooltip>
          </div>
        </div>
      </mt-list-item>
    </mt-list>
    <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerUtilisateur(monUtilisateur)">
      Êtes-vous certain(e) de vouloir supprimer l'utilisateur' ?
    </mt-modal-action>
    <b-pagination
      :total="total"
      :current="pageCourante"
      :per-page="parPage"
      order="is-centered"
      aria-next-label="Utilisateurs suivants"
      aria-previous-label="Utilisateurs précedents"
      aria-page-label="Utilisateurs"
      aria-current-label="Page courante"
      @change="getUtilisateurs"
    />
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import userMixin from '~/components/mixins/userMixin';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
    MtUtilisateur,
  },
  mixins: [userMixin],
  computed: {
    filteredOrganismeArray() {
      const organismesRet = [];
      this.organismes.forEach((brigade) => {
        if (this.estRecherche(brigade)) {
          if (this.isAdminBrigade) {
            organismesRet.push(brigade);
          }
        }
        brigade.organismesEnfants.forEach((regiment) => {
          if (this.estRecherche(regiment)) {
            organismesRet.push(regiment);
          }
          regiment.organismesEnfants.forEach((unite) => {
            if (this.estRecherche(unite)) {
              organismesRet.push(unite);
            }
          });
        });
      });
      return organismesRet;
    },
  },
  async asyncData(context) {
    const { idOrganisme } = context.params;
    let organismeSearch = '';
    let mOrganisme = null;
    const pageCourante = 1;
    const parPage = 20;
    const sortBy = 'nom';
    const order = 'ASC';
    const filtreNom = '';
    const oldFiltre = '';
    const isAdmin = context.store.getters['context/isAdmin'];
    const isAdminBrigade = context.store.getters['context/isAdminBrigade'];
    const mapTri = new Map();
    mapTri.set('nom', 'sort-ascending');
    mapTri.set('prenom', 'none');
    mapTri.set('email', 'none');
    mapTri.set('o.code', 'none');
    const organismes = await context.$api.organismes.allHiearchie();
    let idOrg;
    if (isAdminBrigade) {
      idOrg = organismes[0].id;
    } else {
      idOrg = organismes[0].organismesEnfants[0].id;
    }
    let req = null;
    if (idOrganisme != null) {
      mOrganisme = await context.$api.organismes.get(idOrganisme);
      organismeSearch = mOrganisme.code;
      req = context.$api.organismes.allUtilisateursSort(
        idOrganisme,
        pageCourante - 1,
        parPage,
        sortBy,
        order,
        filtreNom,
      );
    } else if (isAdmin) {
      req = context.$api.utilisateurs.allDashboardSort(pageCourante - 1, parPage, sortBy, order, filtreNom);
    } else {
      req = context.$api.organismes.allUtilisateursSort(idOrg, pageCourante - 1, parPage, sortBy, order, filtreNom);
    }
    const { content: utilisateurs, totalElements: total, numberOfElements: nombrePageCourante } = await req;

    return {
      utilisateurs,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      monUtilisateur: null,
      sortBy,
      order,
      filtreNom,
      oldFiltre,
      mapTri,
      enabled: '',
      organismes,
      mOrganisme,
      organismeSearch,
      isAdminBrigade,
    };
  },
  methods: {
    async getUtilisateurs(page) {
      this.pageCourante = page;
      let idOrg;
      if (this.isAdminBrigade) {
        idOrg = this.organismes[0].id;
      } else {
        idOrg = this.organismes[0].organismesEnfants[0].id;
      }
      let req = null;
      if (this.mOrganisme != null) {
        req = this.$api.organismes.allUtilisateursSort(
          this.mOrganisme.id,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.enabled,
        );
      } else if (!this.isAdmin) {
        req = this.$api.organismes.allUtilisateursSort(
          idOrg,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.enabled,
        );
      } else {
        req = this.$api.utilisateurs.allDashboardSort(
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.enabled,
        );
      }
      ({
        content: this.utilisateurs,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await req);
    },
    filteredUtil() {
      if (this.filtreNom !== this.oldFiltre) {
        this.oldFiltre = this.filtreNom;
        this.getUtilisateurs(1);
      }
      return this.utilisateurs;
    },
    confirmeSupprimer(utilisateur) {
      this.ouvertDelete = true;
      this.monUtilisateur = utilisateur;
    },
    triEnabled() {
      this.getUtilisateurs(this.pageCourante);
    },
    tri(ordreTri) {
      this.mapTri.forEach(function tri(value, key) {
        if (key === ordreTri) {
          if (value === 'none') {
            this.sortBy = key;
            this.order = 'ASC';
            this.mapTri.set(key, 'sort-ascending');
          } else if (this.order === 'ASC') {
            this.order = 'DESC';
            this.mapTri.set(key, 'sort-descending');
          } else {
            this.order = 'ASC';
            this.mapTri.set(key, 'sort-ascending');
          }
        } else {
          this.mapTri.set(key, 'none');
        }
      }, this);
      this.getUtilisateurs(this.pageCourante);
    },
    getIconOrder(ordreTri) {
      return this.mapTri.get(ordreTri);
    },
    async supprimerUtilisateur(utilisateur) {
      try {
        await this.$api.utilisateurs.delete(utilisateur.id);
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getUtilisateurs(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    estRecherche(organisme) {
      return (
        organisme.code
          .toString()
          .toLowerCase()
          .includes(this.organismeSearch.toLowerCase()) ||
        organisme.libelle
          .toString()
          .toLowerCase()
          .includes(this.organismeSearch.toLowerCase())
      );
    },
    organismeChange() {
      if (this.organismeSearch === '') {
        this.mOrganisme = null;
        this.getUtilisateurs(1);
      }
    },
    async getUtilisateursOrganisme(organisme) {
      this.pageCourante = 1;
      if (organisme !== null) {
        this.mOrganisme = organisme;
        ({
          content: this.utilisateurs,
          totalElements: this.total,
          numberOfElements: this.nombrePageCourante,
        } = await this.$api.organismes.allUtilisateursSort(
          organisme.id,
          this.pageCourante - 1,
          this.parPage,
          this.sortBy,
          this.order,
          this.filtreNom,
          this.enabled,
        ));
      } else {
        this.mOrganisme = null;
        this.getUtilisateurs(1);
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-marginless-bottom {
  margin-bottom: 0;
}
/deep/ .radioButton input {
  visibility: hidden;
  & ~ .control-label {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;
    display: flex;
    align-items: center;

    .icon {
      margin-right: 0.8em;
    }
  }

  &:checked ~ .control-label,
  & ~ .control-label:hover {
    border-color: $soft-blue;
    background-color: $soft-blue;
    color: $white;
  }

  & + .check {
    display: none !important;
    visibility: hidden;
  }
}
/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
.visibility {
  visibility: hidden;
}
.button.is-light {
  border: 1px solid $primary;
  color: $primary;
}
</style>
